# Covid19 FaceMask Detector using CNN & OpenCV.


<div align= "center">
  <h4>Face Mask Detection system built with OpenCV, Keras/TensorFlow using Deep Learning and Computer Vision concepts in order to detect face masks in static images as well as in video streams.</h4>
</div>

&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;

## Live Demo:
<p align="center"><img src="images_demo/FaceMaskGif.gif" width="700" height="400"></p>



## :innocent: Motivation
In the present scenario due to Covid-19, there is no efficient face mask detection applications which are now in high demand for transportation means, densely populated areas, residential districts, large-scale manufacturers and other enterprises to ensure safety. Also, the absence of large datasets of __‘with_mask’__ images has made this task more cumbersome and challenging. 


## :star: Features

This system can be used in real-time applications which require face-mask detection for safety purposes due to the outbreak of Covid-19. This project can be integrated with embedded systems for application in airports, railway stations, offices, schools, and public places to ensure that public safety guidelines are followed.

## :file_folder: Dataset
The dataset used can be downloaded here - [Click to Download](https://www.kaggle.com/prithwirajmitra/covid-face-mask-detection-dataset)


<a href="https://colab.research.google.com/github/cybernobie/covid19-face-mask-detection-cnn-opencv/blob/main/face_mask_detection.ipynb" target="_parent"><img src="https://colab.research.google.com/assets/colab-badge.svg" alt="Open In Colab"/></a>

This dataset consists of __1006 images__ belonging to two classes:
*	__with_mask: 500 images__
*	__without_mask: 606 images__



## 🚀&nbsp; Installation
1. Download the files in this repository and extract them.
2. Run Face_Mask_Detection.ipynb file first 
3. Running the above .ipynb file will generate Model.h5 file.
4. Now Run Mask.py file
5. Done.

NOTE: 
{
<p><b>pip install opencv-python

pip install numpy

pip install keras

pip install tensorflow</b></p> 
To Fix/Install Modules
}

## :key: Results

#### Our model gave 92% accuracy for Face Mask Detection after training via <code>tensorflow==2.3.1</code>

![](images_demo/Screenshot%202020-06-01%20at%209.48.27%20PM.png)

#### We got the following accuracy/loss training curve plot
![](images_demo/plot.png)

## :clap: And it's done!
Feel free to mail me for any doubts/query 
:email: jkarts91@gmail.com

## :heart: Owner
Made with :heart:&nbsp;  by [Aryan Negi](https://github.com/cybernobie)


